#!/usr/local/bin/php -c /etc/php.ini
<?php
/* This PHP Script can be used with External Parsers in SafeSquid Composite / Advanced Editions.
This script requires pamtester.
This script will authenticate users via PAM.
The service name used for PAM can be specified below.
It is not necessary to set the service name as specified in safesquid's "pamfile" option.
This script can be particularly helpful when it is desired to authenticate users when they access, specific content, etc. To do so, create a profile for such content in SafeSquid's Profiles section, and then create a rule in the External Parser Section, to execute this script, for the desired profile.
*/

$service = "safesquid";
ob_start();
$stdin = fopen("php://stdin", "r");
$str = fgets($stdin, 1024);
 // Read the headers 
$auth_flag = "0";
while (($line = fgets($stdin, 1024)) && $line[0] != "\n" && $line[0] != "\r") {
	$type = strtolower(strtok($line, ":"));
	$value = strtok(":");
	$headers[$type] = ltrim($value);
	$caught_value = $headers[$type];
	$caught_type = $type;
	if ($caught_type == "proxy-authorization"){
		$auth_flag = "1";
	}
}

if ($auth_flag == "0" ){
	auth_header();
}

// We are looking for Basic Authentication
$method = strtok($headers["proxy-authorization"]," ");
if ($method != "Basic") {
	auth_header();
}

 // username/password is sent by the browser base64-encoded in the form "username:password" 
$userpass = base64_decode(strtok(" "));
$username = strtok($userpass, ":");
$password = strtok(":");
$passwd = md5($password); 

// Use pamtester to validate the username and password
// Set the service name for pamtester


$ret = system("echo \"$password\" | pamtester $service \"$username\" authenticate");

   if ( !$ret ) {
       auth_header();
	}else{
		exit(1);
	}

exit(1);

function auth_header()
{
	header ( "HTTP/1.1 407 Authorization required\n" );
	header ( "Proxy-Authenticate: Basic realm = \"SafeSquid Secure Browsing Service\"\n" ) ;
		exit(0);
}

?>
